/*! await-timeout v0.1.6 */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["AwaitTimeout"] = factory();
	else
		root["AwaitTimeout"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Promise-based replacement for setTimeout / clearTimeout.
 */

var Timeout = function () {
  function Timeout() {
    _classCallCheck(this, Timeout);

    this._id = null;
  }

  _createClass(Timeout, [{
    key: 'set',
    value: function set(ms) {
      var _this = this;

      var msg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

      return new Promise(function (resolve, reject) {
        var fn = msg ? function () {
          return reject(new Error(msg));
        } : resolve;
        _this._id = setTimeout(fn, ms);
      });
    }
  }, {
    key: 'wrap',
    value: function wrap(promise, ms) {
      var _this2 = this;

      var msg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';

      var wrappedPromise = promiseFinally(promise, function () {
        return _this2.clear();
      });
      var timer = this.set(ms, msg);
      return Promise.race([wrappedPromise, timer]);
    }
  }, {
    key: 'clear',
    value: function clear() {
      clearTimeout(this._id);
    }
  }]);

  return Timeout;
}();

Timeout.set = function (ms, msg) {
  return new Timeout().set(ms, msg);
};

Timeout.wrap = function (promise, ms, msg) {
  return new Timeout().wrap(promise, ms, msg);
};

function promiseFinally(promise, fn) {
  var success = function success(result) {
    fn();
    return result;
  };
  var error = function error(e) {
    fn();
    return Promise.reject(e);
  };
  return Promise.resolve(promise).then(success, error);
}

exports.default = Timeout;
module.exports = exports['default'];

/***/ })
/******/ ]);
});
//# sourceMappingURL=index.umd.js.map